﻿package 
{
	import afterburner.command.config.StartApplication;
	import afterburner.command.config.BuildMVC;
	import afterburner.document.AppliResources;

	import net.pixlib.commands.PXSequencer;


	import net.pixlib.log.PXLogManager;
	import net.pixlib.log.layout.PXDeMonsterDebuggerLayout;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.quick.document.PXDocument;
	import net.pixlib.quick.document.resource.PXDocumentResourceCollection;
	import net.pixlib.utils.PXFlashVars;


	[SWF(backgroundColor="0x02313B")] 
	public class Main extends PXDocument
	{
		
		
		
		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 60
		 * -swf-version=13 : pour activer l'API Stage3D
		 * 
		 */
		public function Main()
		{
			// http://www.actionscript-facile.com/wp-content/uploads/2012/04/afterburner.swf
			// http://www.actionscript-facile.com/swf-exemple-autosize?swf=http://www.actionscript-facile.com/wp-content/uploads/2012/04/afterburner.swf&amp;w=600&amp;h=600
			// http://www.actionscript-facile.com/swf-exemple-autosize?swf=http://www.actionscript-facile.com/wp-content/uploads/2012/04/afterburner.swf&w=600&h=600
			
			// http://www.actionscript-facile.com/swf-exemple-autosize?swf=http://www.actionscript-facile.com/wp-content/uploads/2012/04/afterburner.swf
			// http://www.actionscript-facile.com/swf-exemple?swf=http://www.actionscript-facile.com/wp-content/uploads/2012/04/afterburner.swf
			// http://www.actionscript-facile.com/ressources/assets/src-afterburner/
			
			
			// enregistrement d'une variable Flashvars pour la simuler
			if (!PXFlashVars.getInstance().isRegistered("debug"))
				PXFlashVars.getInstance().register("debug", true);
			
			// la passerelle remoting
			if (!PXFlashVars.getInstance().isRegistered("gateway"))
				//PXFlashVars.getInstance().register("gateway", "http://www.actionscript-facile.com/ressources/remoting/gateway.php");
				PXFlashVars.getInstance().register("gateway", "http://www.actionscript-facile.com/ressources/remoting-2.0.1/index.php");
			
			// si debug active
			if( PXFlashVars.getInstance().getBoolean("debug") )
				PXLogManager.getInstance().addLogListener(PXDeMonsterDebuggerLayout.getInstance());
			
			PXQuick.debug("AfterBurner MODE DEBUG !!!");
		}

		
		/**
		 * Création de notre architecture MVC.
		 * 
		 */
		override protected function get configSequencer() : PXSequencer
		{
			PXQuick.debug("get configSequencer()", this);

			var sequencer : PXSequencer = super.configSequencer;
			sequencer.addCommand(new BuildMVC());
			sequencer.addCommand(new StartApplication());

			return sequencer;
		}


		/**
		 * Définition des ressources de notre application.
		 * 
		 */
		override protected function get resources() : PXDocumentResourceCollection
		{
			PXQuick.debug("get resources()", this);
			return new AppliResources();
		}

		/**
		 * L'application est entièrement initialisée.
		 * 
		 */
		override protected function onDocumentReady() : void
		{
			PXQuick.debug("---> onDocumentReady");
			
			/*
			PXQuick.debug(PXQuick.configuration, this);
			
			// PXCSSStyleClass
			PXQuick.debug("affiche le contenu du fichier css");
			PXQuick.debug(PXQuick.css);// affiche le CSS chargé automatiquement
			
			PXQuick.debug("affiche le contenu du fichier xml");
			PXQuick.debug(PXQuick.configuration);// affiche le xml chargé automatiquement
	*/
			
			//PXQuick.plugin.firePrivateEvent(new PXDimensionEvent(EventList.resizeEVENT, null, PXApplication.getInstance().size));

			// StreamModel(PXQuick.getModel(ModelList.STREAM)).load(PXFlashVars.getInstance().getString("file"));
			// PXQuick.plugin.firePrivateEvent(new NumberEvent(EventList.initCommandChainEVENT, null, PXFlashVars.getInstance().getNumber("vid")));
			// PXQuick.plugin.firePrivateEvent(new NumberEvent(EventList.initCommandSequenceEVENT, null, PXFlashVars.getInstance().getNumber("vid")));
			
			//PXQuick.plugin.firePrivateEvent(new PXNumberEvent(EventList.initMultiServicesEVENT, null, PXFlashVars.getInstance().getNumber("vid")));
		}
	}
}