package afterburner.view.game
{

	import com.actionscriptfacile.ui.text.UITextField;
	
	
	import afterburner.view.ViewList;
	
	
	import flash.display.DisplayObject;
	
	
	
	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.events.PXStringEvent;
	import net.pixlib.view.PXContainerView;
	
	

	/**
	 * @author Matthieu
	 */
	public class InterfaceView extends PXContainerView
	{
		
		private var oTxtLoadProgress : UITextField;
		private var oTxtInputNamePlayer : UITextField;
		private var oTxtNamePlayer : UITextField;



		public function InterfaceView(owner : PXPlugin = null, mc : DisplayObject = null)
		{
			super(owner, ViewList.INTERFACE, mc);
		}

		/**
		 * Methode appelez après l'instanciation d'une AbstractView
		 */
		override protected function onInitView() : void
		{
			// hide();
			show();
			_buildView();
		}


		private function _buildView() : void
		{
			oTxtLoadProgress = this.addText("...");
			oTxtLoadProgress.x = 20;
			oTxtLoadProgress.y = 10;
			addChild(oTxtLoadProgress);
			
			//logger.debug(" InterfaceViwe _buildView : "+oTxtLoadProgress.text, this);
			
			oTxtNamePlayer = this.addText("Saisissez votre Prénom :");
			oTxtNamePlayer.x = oTxtLoadProgress.x;
			oTxtNamePlayer.y = 50;
			addChild(oTxtNamePlayer);
			oTxtNamePlayer.visible = false;
			
			oTxtInputNamePlayer = this.addText("");
			oTxtInputNamePlayer.x = oTxtNamePlayer.x + oTxtNamePlayer.width;
			oTxtInputNamePlayer.y = oTxtNamePlayer.y;
			oTxtInputNamePlayer.convertToInput();
			oTxtInputNamePlayer.changeFormat("color", 0x006f77);// changement de la couleur
			oTxtInputNamePlayer.selectable = true;
			oTxtInputNamePlayer.border = true;
			oTxtInputNamePlayer.borderColor = 0x006f77;
			
			oTxtInputNamePlayer.maxHeight =  oTxtInputNamePlayer.height = 100;
			oTxtInputNamePlayer.maxWidth =  oTxtInputNamePlayer.width = 230;
			
			addChild(oTxtInputNamePlayer);
			oTxtInputNamePlayer.visible = false;
		}


		/**
		 * Appel par une commande.
		 * 
		 */
		public function onStopGame() : void
		{
			oTxtInputNamePlayer.visible = oTxtNamePlayer.visible = true;
		}
		

		/**
		 * Prépare le lancement d'une nouvelle partie.
		 * 
		 */
		public function onStartGame() : void
		{
			oTxtInputNamePlayer.visible = oTxtNamePlayer.visible = false;
		}
		
		
		/**
		 * Renvoie le nom du joueur.
		 * 
		 */
		public function getPlayerName() : String
		{
			oTxtInputNamePlayer.visible = oTxtNamePlayer.visible = false;
			return oTxtInputNamePlayer.text;
		}

		
		
		/**
		 * Appel par un évènement AppliModel après le chargement des éléments graphiques.
		 * 
		 * content pour récupérer le DisplayObject en cours.
		 * 
		 */
		public function onAssetsLoadProgress(event : PXStringEvent) : void
		{
			//logger.debug(" txt onAssetsLoadProgress : "+event.value, this);
			oTxtLoadProgress.text = event.value;
		}
		
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 31);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x00C5DF);// changement de la couleur
			oTxtField.changeFormat("bold", true);// changement de la taille de la police du texte
			
			return oTxtField;	 
		}
	}
}