/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.engine.elements
{
	
	import starling.display.Sprite;
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.textures.Texture;	
	


	/**
	 * Gestion des caractéristiques d'une balle.
	 * 
	 */
	public class Explosion
	{
		private var aParticules:Vector.<DebrisVaisseau>;// contient une référence de tous les ennemis.
		
		private var oMovieExplosion : MovieClip = null;
		private var oMovie : Sprite = null;

				
				
		/**
		 * Constructeur.
		 * Ajoute un ennemi positionné aléatoirement.
		 * 
		 */
		public function Explosion(framesVaisseau:Vector.<Texture>, framesExplosion:Vector.<Texture>, x:Number = 0, y:Number = 0)
		{
			this.init(framesVaisseau, framesExplosion, x , y);
		}
		
		
		/**
		 * Init de la création de l'ennemi.
		 * 
		 */
		private function init(framesVaisseau:Vector.<Texture>, framesExplosion:Vector.<Texture>, x:Number = 0, y:Number = 0) : void
		{
			aParticules = new Vector.<DebrisVaisseau>();
			
			oMovie = new Sprite();
			oMovie.x = x;
			oMovie.y = y;
			
			/* init de l'affichage */
			oMovieExplosion = new MovieClip(framesExplosion, 60);
			Starling.juggler.add ( oMovieExplosion );
			oMovie.addChild(oMovieExplosion);
			
			
			/*var oDebris:DebrisVaisseau;
			for (var i : int = 0; i < 13; i++)
			{
				oDebris = new DebrisVaisseau(framesVaisseau);
				aParticules.push(oDebris);	
				oMovie.addChild(oDebris.clip);
			}*/
		}
		
		
		

		/**
		 * Renvoie le clip pour ajout sur la scène
		 */
		public function get clip() : Sprite {return oMovie;}
		
		
		
		/**
		 * Mise à jour du mouvement de l'ennemis.
		 * 
		 */
		public function update() : void
		{
			var oDebris:DebrisVaisseau;
			for (var i : int = 0; i < aParticules.length; i++)
			{
				oDebris = aParticules[i];
				oDebris.update();
				
				// suppression des débris s'ils ne sont plus affichés
				if( oDebris.life <= 0)
				{
					aParticules.slice(i,1);
					oMovie.removeChild(oDebris.clip);
					oDebris.dispose();
				}
			}
			
			if(oMovieExplosion.currentFrame == oMovieExplosion.numFrames-1 )
				oMovieExplosion.visible = false;
				
			// si les 2 clips sont invisibles, passage a false du clip Maitre pour destruction par ExplosionManager
			if( oMovieExplosion.visible == false &&  aParticules.length == 0 )
				oMovie.visible = false;
		}

		
		/**
		 * Supprime les ressources graphiques utilisées par l'ennemis.
		 * 
		 */
		private function remove() : void
		{
			if( oMovie != null )
			{
				Starling.juggler.remove ( oMovieExplosion );
				
				oMovie.removeChild(oMovieExplosion);
				
				var oDebris:DebrisVaisseau;
				for (var i : int = 0; i < aParticules.length; i++)
				{
					oDebris = aParticules[i];
					aParticules.slice(i,1);
					oDebris.dispose();
				}
			
				oMovieExplosion.removeFromParent(true);
				oMovie.removeFromParent(true);
				oMovie = null; 				
			}
			
		}


		/**
		 * Supprime les ressources utilisées par l'ennemis.
		 * 
		 */
		public function dispose() : void
		{
			this.remove();
		}
		
	}
}