/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.stage3D
{
	
	import starling.display.BlendMode;
	import afterburner.view.ViewList;
	import afterburner.view.util.Assets;
	import flash.display.DisplayObject;
	import net.pixlib.plugin.PXPlugin;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.view.PXContainerView;
	import starling.display.DisplayObjectContainer;
	import starling.display.MovieClip;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	

	
	
	
	

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class Background extends PXContainerView
	{
		private var oMovieBack1 : MovieClip;
		private var oMovieBack2 : MovieClip;
		private var oMovieBack3 : MovieClip;
		private var nSpeedDefil : int = 4;
		
		
		private var oDisplay : DisplayObjectContainer;// le contenu Stage3D
				
		public function Background(owner : PXPlugin = null, mc : DisplayObject = null)
		{
			super(owner, ViewList.STAGE_3D_BACKGROUND, mc);
		}

		
		/**
		 * Methode appelez après l'instanciation d'une abstractUI
		 */
		override protected function onInitView() : void
		{
			//hide();
			show();
		}
		
		
		public function setDisplay3D(display:DisplayObjectContainer) : void
		{
			oDisplay = display;
			oDisplay.blendMode = BlendMode.NONE;
			this.buildUI();
		}
		
		
		private function buildUI() : void
		{
			//logger.debug(" background buildUI ", this);
			
			// ajout d'une texture
			var texture:Texture = Assets.getInstance().getTexture("BackgroundAnim");
						
			var xml : XML = Assets.getInstance().getDataXml("SpriteSheetXmlBackground");
			var sTextureAtlas : TextureAtlas = new TextureAtlas(texture, xml);
			
			var frames : Vector.<Texture> = sTextureAtlas.getTextures("FloorTexture");
			
			/* création des MovieClip du décord défilant */
			oMovieBack1 = new MovieClip(frames);
			oMovieBack1.currentFrame = 0;
			oDisplay.addChild(oMovieBack1);
			
			oMovieBack2 = new MovieClip(frames);
			oMovieBack2.currentFrame = 1;
			oMovieBack2.y = oMovieBack1.y - oMovieBack1.height;
			oDisplay.addChild(oMovieBack2);
			
			oMovieBack3 = new MovieClip(frames);
			oMovieBack3.currentFrame = 2;
			oMovieBack3.y = oMovieBack2.y - oMovieBack2.height;
			oDisplay.addChild(oMovieBack3);
			
			// écouteur sur chaque image par seconde
			oDisplay.stage.addEventListener(starling.events.Event.ENTER_FRAME, onFrame);
		}

		
		/**
		 * Mise à jour toutes les images pour effectuer le défilement du décor.
		 * 
		 */
		private function onFrame(e : Event) : void
		{
			oMovieBack1.y = oMovieBack1.y + nSpeedDefil;
			oMovieBack2.y = oMovieBack2.y + nSpeedDefil;
			oMovieBack3.y = oMovieBack3.y + nSpeedDefil;
			
			// repositionne les images lorsqu'elles sortent de l'écran
			if(oMovieBack1.y > oMovieBack1.height)	oMovieBack1.y = oMovieBack3.y - oMovieBack1.height;
			if(oMovieBack2.y > oMovieBack2.height)	oMovieBack2.y = oMovieBack1.y - oMovieBack2.height;
			if(oMovieBack3.y > oMovieBack3.height)	oMovieBack3.y = oMovieBack2.y - oMovieBack3.height;
		} 
		
	}
}