/*
 * Copyright the original author or authors.
 * 
 * Licensed under the MOZILLA PUBLIC LICENSE, Version 1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.mozilla.org/MPL/MPL-1.1.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 
package net.pixlib.load 
{
	import net.pixlib.load.strategy.PXStreamLoaderStrategy;

	import flash.net.URLStream;
	
	/**
	 * The PXStreamLoader class allow to load content using 
	 * <code>URLStream</code> loader.
	 * 
	 * @see net.pixlib.load.strategy.PXStreamLoaderStrategy
	 * 
	 * @langversion 3.0
	 * @playerversion Flash 10
	 * 
	 * @author 	Romain Ecarnot
	 */
	public class PXStreamLoader extends PXAbstractLoader
	{
		//--------------------------------------------------------------------
		// Public API
		//--------------------------------------------------------------------
		
		/**
		 * Creates new instance.
		 * 
		 * @langversion 3.0
		 * @playerversion Flash 10
		 */	
		public function PXStreamLoader(key : String = null)
		{
			super(new PXStreamLoaderStrategy());
			
			name = key;
		}
		
		/**
		 * Returns URLStream content.
		 * 
		 * @return	The URLStream content
		 * 
		 * @langversion 3.0
		 * @playerversion Flash 10
		 */
		public function getStream() : URLStream
		{
			return URLStream(content);
		}
	}
}
